<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.junit.textui;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import java.io.PrintStream;<a name="line.36"></a>
<FONT color="green">037</FONT>    <a name="line.37"></a>
<FONT color="green">038</FONT>    import junit.framework.Test;<a name="line.38"></a>
<FONT color="green">039</FONT>    import junit.framework.TestCase;<a name="line.39"></a>
<FONT color="green">040</FONT>    import junit.framework.TestResult;<a name="line.40"></a>
<FONT color="green">041</FONT>    import junit.framework.TestSuite;<a name="line.41"></a>
<FONT color="green">042</FONT>    import junit.runner.Version;<a name="line.42"></a>
<FONT color="green">043</FONT>    import junit.textui.ResultPrinter;<a name="line.43"></a>
<FONT color="green">044</FONT>    <a name="line.44"></a>
<FONT color="green">045</FONT>    /**<a name="line.45"></a>
<FONT color="green">046</FONT>     * A command line based tool to run tests.<a name="line.46"></a>
<FONT color="green">047</FONT>     * &lt;pre&gt;<a name="line.47"></a>
<FONT color="green">048</FONT>     * java junit.textui.TestRunner [-wait] TestCaseClass<a name="line.48"></a>
<FONT color="green">049</FONT>     * &lt;/pre&gt;<a name="line.49"></a>
<FONT color="green">050</FONT>     * TestRunner expects the name of a TestCase class as argument.<a name="line.50"></a>
<FONT color="green">051</FONT>     * If this class defines a static &lt;code&gt;suite&lt;/code&gt; method it <a name="line.51"></a>
<FONT color="green">052</FONT>     * will be invoked and the returned test is run. Otherwise all <a name="line.52"></a>
<FONT color="green">053</FONT>     * the methods starting with "test" having no arguments are run.<a name="line.53"></a>
<FONT color="green">054</FONT>     * &lt;p&gt;<a name="line.54"></a>
<FONT color="green">055</FONT>     * When the wait command line argument is given TestRunner<a name="line.55"></a>
<FONT color="green">056</FONT>     * waits until the users types RETURN.<a name="line.56"></a>
<FONT color="green">057</FONT>     * &lt;p&gt;<a name="line.57"></a>
<FONT color="green">058</FONT>     * TestRunner prints a trace as the tests are executed followed by a<a name="line.58"></a>
<FONT color="green">059</FONT>     * summary at the end. <a name="line.59"></a>
<FONT color="green">060</FONT>     */<a name="line.60"></a>
<FONT color="green">061</FONT>    public class TestRunner extends junit.textui.TestRunner {<a name="line.61"></a>
<FONT color="green">062</FONT>    <a name="line.62"></a>
<FONT color="green">063</FONT>            /**<a name="line.63"></a>
<FONT color="green">064</FONT>             * Constructs a TestRunner.<a name="line.64"></a>
<FONT color="green">065</FONT>             */<a name="line.65"></a>
<FONT color="green">066</FONT>            public TestRunner() {<a name="line.66"></a>
<FONT color="green">067</FONT>                    super();<a name="line.67"></a>
<FONT color="green">068</FONT>            }<a name="line.68"></a>
<FONT color="green">069</FONT>    <a name="line.69"></a>
<FONT color="green">070</FONT>            /**<a name="line.70"></a>
<FONT color="green">071</FONT>             * Constructs a TestRunner using the given stream for all the output<a name="line.71"></a>
<FONT color="green">072</FONT>             */<a name="line.72"></a>
<FONT color="green">073</FONT>            public TestRunner(PrintStream writer) {<a name="line.73"></a>
<FONT color="green">074</FONT>                    super(writer);<a name="line.74"></a>
<FONT color="green">075</FONT>            }<a name="line.75"></a>
<FONT color="green">076</FONT>            <a name="line.76"></a>
<FONT color="green">077</FONT>            /**<a name="line.77"></a>
<FONT color="green">078</FONT>             * Constructs a TestRunner using the given ResultPrinter all the output<a name="line.78"></a>
<FONT color="green">079</FONT>             */<a name="line.79"></a>
<FONT color="green">080</FONT>            public TestRunner(ResultPrinter printer) {<a name="line.80"></a>
<FONT color="green">081</FONT>                    super(printer);<a name="line.81"></a>
<FONT color="green">082</FONT>            }<a name="line.82"></a>
<FONT color="green">083</FONT>            <a name="line.83"></a>
<FONT color="green">084</FONT>            @Override<a name="line.84"></a>
<FONT color="green">085</FONT>            public Test getTest(String suiteClassName) {<a name="line.85"></a>
<FONT color="green">086</FONT>                    String className        = suiteClassName;<a name="line.86"></a>
<FONT color="green">087</FONT>                    String methodName       = null;<a name="line.87"></a>
<FONT color="green">088</FONT>                    int index = suiteClassName.indexOf('#'); <a name="line.88"></a>
<FONT color="green">089</FONT>                    if (index &gt; 0) {<a name="line.89"></a>
<FONT color="green">090</FONT>                            className       = suiteClassName.substring(0, index);<a name="line.90"></a>
<FONT color="green">091</FONT>                            methodName      = suiteClassName.substring(index + 1);<a name="line.91"></a>
<FONT color="green">092</FONT>                    }<a name="line.92"></a>
<FONT color="green">093</FONT>                    Test test = super.getTest(className);<a name="line.93"></a>
<FONT color="green">094</FONT>                    if (methodName != null &amp;&amp; test instanceof TestSuite) {<a name="line.94"></a>
<FONT color="green">095</FONT>                            TestSuite suite = (TestSuite)test;<a name="line.95"></a>
<FONT color="green">096</FONT>                            for (int ii = 0; ii &lt; suite.testCount(); ii++) {<a name="line.96"></a>
<FONT color="green">097</FONT>                                    Test methodTest = suite.testAt(ii);<a name="line.97"></a>
<FONT color="green">098</FONT>                                    if (methodTest instanceof TestCase) {<a name="line.98"></a>
<FONT color="green">099</FONT>                                            if (methodName.equals(((TestCase)methodTest).getName())) {<a name="line.99"></a>
<FONT color="green">100</FONT>                                                    return methodTest;<a name="line.100"></a>
<FONT color="green">101</FONT>                                            }<a name="line.101"></a>
<FONT color="green">102</FONT>                                    }<a name="line.102"></a>
<FONT color="green">103</FONT>                            }<a name="line.103"></a>
<FONT color="green">104</FONT>                            runFailed("StackTrace \"" + methodName + "\" not found in class \"" + className + "\"");<a name="line.104"></a>
<FONT color="green">105</FONT>                            return null;<a name="line.105"></a>
<FONT color="green">106</FONT>                    }<a name="line.106"></a>
<FONT color="green">107</FONT>                    return test;<a name="line.107"></a>
<FONT color="green">108</FONT>            }<a name="line.108"></a>
<FONT color="green">109</FONT>            <a name="line.109"></a>
<FONT color="green">110</FONT>            /**<a name="line.110"></a>
<FONT color="green">111</FONT>             * Starts a test run. Analyzes the command line arguments<a name="line.111"></a>
<FONT color="green">112</FONT>             * and runs the given test suite.<a name="line.112"></a>
<FONT color="green">113</FONT>             */<a name="line.113"></a>
<FONT color="green">114</FONT>            @Override<a name="line.114"></a>
<FONT color="green">115</FONT>            public TestResult start(String args[]) throws Exception {<a name="line.115"></a>
<FONT color="green">116</FONT>                    String testCase= "";<a name="line.116"></a>
<FONT color="green">117</FONT>                    boolean wait= false;<a name="line.117"></a>
<FONT color="green">118</FONT>                    <a name="line.118"></a>
<FONT color="green">119</FONT>                    for (int i= 0; i &lt; args.length; i++) {<a name="line.119"></a>
<FONT color="green">120</FONT>                            if (args[i].equals("-wait"))<a name="line.120"></a>
<FONT color="green">121</FONT>                                    wait= true;<a name="line.121"></a>
<FONT color="green">122</FONT>                            else if (args[i].equals("-c")) <a name="line.122"></a>
<FONT color="green">123</FONT>                                    testCase= extractClassName(args[++i]);<a name="line.123"></a>
<FONT color="green">124</FONT>                            else if (args[i].equals("-v"))<a name="line.124"></a>
<FONT color="green">125</FONT>                                    System.err.println("JUnit "+Version.id()+" by Kent Beck and Erich Gamma");<a name="line.125"></a>
<FONT color="green">126</FONT>                            else<a name="line.126"></a>
<FONT color="green">127</FONT>                                    testCase= args[i];<a name="line.127"></a>
<FONT color="green">128</FONT>                    }<a name="line.128"></a>
<FONT color="green">129</FONT>                    <a name="line.129"></a>
<FONT color="green">130</FONT>                    if (testCase.equals("")) <a name="line.130"></a>
<FONT color="green">131</FONT>                            throw new Exception("Usage: TestName[#testCaseName] [-wait], where TestName is the name of the TestCase class, testCaseName that of a test method");<a name="line.131"></a>
<FONT color="green">132</FONT>    <a name="line.132"></a>
<FONT color="green">133</FONT>                    try {<a name="line.133"></a>
<FONT color="green">134</FONT>                            Test suite= getTest(testCase);<a name="line.134"></a>
<FONT color="green">135</FONT>                            return doRun(suite, wait);<a name="line.135"></a>
<FONT color="green">136</FONT>                    }<a name="line.136"></a>
<FONT color="green">137</FONT>                    catch(Exception e) {<a name="line.137"></a>
<FONT color="green">138</FONT>                            throw new Exception("Could not create and run test suite: "+e);<a name="line.138"></a>
<FONT color="green">139</FONT>                    }<a name="line.139"></a>
<FONT color="green">140</FONT>            }<a name="line.140"></a>
<FONT color="green">141</FONT>    <a name="line.141"></a>
<FONT color="green">142</FONT>            public static void main(String args[]) {<a name="line.142"></a>
<FONT color="green">143</FONT>                    TestRunner aTestRunner= new TestRunner();<a name="line.143"></a>
<FONT color="green">144</FONT>                    try {<a name="line.144"></a>
<FONT color="green">145</FONT>                            TestResult r= aTestRunner.start(args);<a name="line.145"></a>
<FONT color="green">146</FONT>                            if (!r.wasSuccessful()) <a name="line.146"></a>
<FONT color="green">147</FONT>                                    System.exit(FAILURE_EXIT);<a name="line.147"></a>
<FONT color="green">148</FONT>                            System.exit(SUCCESS_EXIT);<a name="line.148"></a>
<FONT color="green">149</FONT>                    } catch(Exception e) {<a name="line.149"></a>
<FONT color="green">150</FONT>                            System.err.println(e.getMessage());<a name="line.150"></a>
<FONT color="green">151</FONT>                            System.exit(EXCEPTION_EXIT);<a name="line.151"></a>
<FONT color="green">152</FONT>                    }<a name="line.152"></a>
<FONT color="green">153</FONT>            }       <a name="line.153"></a>
<FONT color="green">154</FONT>            <a name="line.154"></a>
<FONT color="green">155</FONT>    }<a name="line.155"></a>




























































</PRE>
</BODY>
</HTML>
